import java.net.Socket;
import java.io.*;
import java.util.Scanner;

/* Class OnClientConnetion: a specialization of Runnable 
 * constructor: it is initialized with an already open socket to the client 
 * run: reads a line from the connected socket and writes it back (prefixed by an incremented line number) in the same socket
 */

public class OneClientConnection implements Runnable{
    private Socket clientSocket;
    public OneClientConnection(Socket clientSocket){
	this.clientSocket = clientSocket;
    }
    public void run(){
	  Scanner in;
	  PrintWriter out;
	  try{
	     in = new Scanner(new BufferedInputStream(clientSocket.getInputStream()));
 	     out = new PrintWriter(clientSocket.getOutputStream(), true); 
	     String s;
	     int i = 0;
	     while(in.hasNextLine()){
 		   s = in.nextLine(); 
		   System.err.println(s);
		   out.println("["+i+"]  " + s);
		   i++;
	     }
         System.err.println("Closing connection with client");
	     out.close();
	     in.close();
	     clientSocket.close();
	  }
	  catch(IOException ioe){System.out.println(ioe);}
    }
}